--- EntityType.original.java	2008-09-10 13:19:48.000000000 +0300
+++ EntityType.java	2009-03-04 10:48:23.128125000 +0200
@@ -619,28 +619,42 @@
 	public Object loadByUniqueKey(
 			String entityName, 
 			String uniqueKeyPropertyName, 
 			Object key, 
 			SessionImplementor session) throws HibernateException {
 		final SessionFactoryImplementor factory = session.getFactory();
 		UniqueKeyLoadable persister = ( UniqueKeyLoadable ) factory.getEntityPersister( entityName );
 
 		//TODO: implement caching?! proxies?!
 
 		EntityUniqueKey euk = new EntityUniqueKey(
 				entityName, 
 				uniqueKeyPropertyName, 
 				key, 
 				getIdentifierOrUniqueKeyType( factory ),
 				session.getEntityMode(), 
 				session.getFactory()
 		);
 
 		final PersistenceContext persistenceContext = session.getPersistenceContext();
 		Object result = persistenceContext.getEntity( euk );
 		if ( result == null ) {
+
+            if (entityName.equals(key.getClass().getName()))
+            {
+                // key is an instatnce of our entity class.
+                // Lets check it's primary key: if primary key
+                // is null, the object is just produced by 
+                // left outer join and the record is absent in DB.
+                Object idValue = persister.getPropertyValue(key, 0, EntityMode.POJO);
+                if (null == idValue)
+                {
+                    return null;
+                }
+            }
+
 			result = persister.loadByUniqueKey( uniqueKeyPropertyName, key, session );
 		}
 		return result == null ? null : persistenceContext.proxyFor( result );
 	}
 
 }
